with Interfaces.C.Strings; use Interfaces.C.Strings;
with Sessions; use Sessions;
with Ada.Strings.Unbounded;use Ada.Strings.Unbounded;
package Connections is

  type Connection is tagged limited private;
  pragma CPP_Class(Connection);

  procedure Close (Con : Connection);
  pragma Import (C_Plus_Plus, Close, "_ZN11ConnectionC5CloseEv");

  procedure Start_Session (Con : Connection; Ses : Session);
  pragma Import (C_Plus_Plus, Start_Session, "_ZNK11ConnectionC12StartSessionE8SessionC");

  procedure Open(Con : in out Connection; Host : Unbounded_String; Port : Integer; 
		Uid : Unbounded_String; Pwd : Unbounded_String);

  function New_Connection return Connection'class;
  pragma CPP_Constructor (New_Connection);
  pragma Import(CPP, New_Connection, "_ZN11ConnectionCC1Ev");  

  private
    type Connection is tagged limited record
      null;
    end record;

end Connections;
