with Interfaces.C.Strings; use Interfaces.C.Strings;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
package Messages is

  type Message is tagged private;
  pragma CPP_Class(Message);

  procedure Set_Message(Msg : Message; P : Integer; rK : Unbounded_String; eT : Integer; dM : Unbounded_String; cT : Unbounded_String; cE : Unbounded_String; Content : Unbounded_String);

  function Get_Content(Msg : Message) return Unbounded_String;

  function New_Message return Message'class;
  pragma CPP_Constructor (New_Message);
  pragma Import(CPP, New_Message, "_ZN8MessageCC1Ev");

  private
    type Message is tagged record
      Prior : Integer;
      Routing_Key : chars_ptr;
      Expiration_Time : Integer;
      Delivery_Mode : chars_ptr;
      Content_Type : chars_ptr;
      Content_Encoding : chars_ptr;
      Content : chars_ptr;
    end record;

end Messages;

